<div>
  <h2>
    <span id="user-management-page-heading" csiTranslate="userManagement.home.title" data-cy="userManagementPageHeading">Users</span>

    <div class="d-flex justify-content-end">
      <button class="btn btn-info me-2" (click)="loadAll()" [disabled]="isLoading">
        <fa-icon icon="sync" [spin]="isLoading"></fa-icon>
        <span csiTranslate="userManagement.home.refreshListLabel">Refresh List</span>
      </button>
      <button class="btn btn-primary jh-create-entity" [routerLink]="['./new']">
        <fa-icon icon="plus"></fa-icon> <span csiTranslate="userManagement.home.createLabel">Create a new User</span>
      </button>
    </div>
  </h2>

  <csi-alert-error></csi-alert-error>

  <csi-alert></csi-alert>

  <div class="table-responsive" *ngIf="users">
    <table class="table table-striped" aria-describedby="user-management-page-heading">
      <thead>
        <tr csiSort [(predicate)]="predicate" [(ascending)]="ascending" (sortChange)="transition()">
          <th scope="col" csiSortBy="id"><span csiTranslate="global.field.id">ID</span> <fa-icon icon="sort"></fa-icon></th>
          <th scope="col" csiSortBy="login"><span csiTranslate="userManagement.login">Login</span> <fa-icon icon="sort"></fa-icon></th>
          <th scope="col" csiSortBy="email"><span csiTranslate="userManagement.email">Email</span> <fa-icon icon="sort"></fa-icon></th>
          <th scope="col"></th>
          <th scope="col" csiSortBy="langKey">
            <span csiTranslate="userManagement.langKey">Lang Key</span> <fa-icon icon="sort"></fa-icon>
          </th>
          <th scope="col"><span csiTranslate="userManagement.profiles">Profiles</span></th>
          <th scope="col" csiSortBy="createdDate">
            <span csiTranslate="userManagement.createdDate">Created Date</span> <fa-icon icon="sort"></fa-icon>
          </th>
          <th scope="col" csiSortBy="lastModifiedBy">
            <span csiTranslate="userManagement.lastModifiedBy">Last Modified By</span> <fa-icon icon="sort"></fa-icon>
          </th>
          <th scope="col" csiSortBy="lastModifiedDate">
            <span csiTranslate="userManagement.lastModifiedDate">Last Modified Date</span> <fa-icon icon="sort"></fa-icon>
          </th>
          <th scope="col"></th>
        </tr>
      </thead>
      <tbody *ngIf="users">
        <tr *ngFor="let user of users; trackBy: trackIdentity">
          <td>
            <a [routerLink]="['./', user.login, 'view']">{{ user.id }}</a>
          </td>
          <td>{{ user.login }}</td>
          <td>{{ user.email }}</td>
          <td>
            <button
              class="btn btn-danger btn-sm"
              (click)="setActive(user, true)"
              *ngIf="!user.activated"
              csiTranslate="userManagement.deactivated"
            >
              Deactivated
            </button>
            <button
              class="btn btn-success btn-sm"
              (click)="setActive(user, false)"
              *ngIf="user.activated"
              [disabled]="!currentAccount || currentAccount.login === user.login"
              csiTranslate="userManagement.activated"
            >
              Activated
            </button>
          </td>
          <td>{{ user.langKey }}</td>
          <td>
            <div *ngFor="let authority of user.authorities">
              <span class="badge bg-info">{{ authority }}</span>
            </div>
          </td>
          <td>{{ user.createdDate | date: 'dd/MM/yy HH:mm' }}</td>
          <td>{{ user.lastModifiedBy }}</td>
          <td>{{ user.lastModifiedDate | date: 'dd/MM/yy HH:mm' }}</td>
          <td class="text-end">
            <div class="btn-group">
              <button type="submit" [routerLink]="['./', user.login, 'view']" class="btn btn-info btn-sm">
                <fa-icon icon="eye"></fa-icon>
                <span class="d-none d-md-inline" csiTranslate="entity.action.view">View</span>
              </button>

              <button type="submit" [routerLink]="['./', user.login, 'edit']" queryParamsHandling="merge" class="btn btn-primary btn-sm">
                <fa-icon icon="pencil-alt"></fa-icon>
                <span class="d-none d-md-inline" csiTranslate="entity.action.edit">Edit</span>
              </button>

              <button
                type="button"
                (click)="deleteUser(user)"
                class="btn btn-danger btn-sm"
                [disabled]="!currentAccount || currentAccount.login === user.login"
              >
                <fa-icon icon="times"></fa-icon>
                <span class="d-none d-md-inline" csiTranslate="entity.action.delete">Delete</span>
              </button>
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>

  <div *ngIf="users">
    <div class="d-flex justify-content-center">
      <csi-item-count [params]="{ page: page, totalItems: totalItems, itemsPerPage: itemsPerPage }"></csi-item-count>
    </div>

    <div class="d-flex justify-content-center">
      <ngb-pagination
        [collectionSize]="totalItems"
        [(page)]="page"
        [pageSize]="itemsPerPage"
        [maxSize]="5"
        [rotate]="true"
        [boundaryLinks]="true"
        (pageChange)="transition()"
      ></ngb-pagination>
    </div>
  </div>
</div>
